<copyright> GP FlatRule class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright (C) 1998 Pieter J. Schoenmakers.

    This file is part of GP.  GP is distributed under the terms of the
    GP License, a copy of which can be found in the GP distribution; see
    the file LICENSE.

    <id>$Id: FlatRule.t,v 1.3 1998/11/10 17:28:39 tiggr Exp $</id>
    </copyright>

implementation class
FlatRule: Element

instance (id)
	for NonTerminal nt
  expansion Element rhs
pre
  nt != nil && rhs != nil
{
  = [[self alloc] init (nt, rhs)];
}

end;

implementation instance
FlatRule
{
  NonTerminal lhs;
  public Element rhs;
}

id (self)
  init (NonTerminal, Element) (l, r)
{
  (lhs, rhs) = (l, r);

  // line = [[parser rules][[lhs name]] line];
  [lhs add-flat-rule self];
}

OutputStream (s)
  describe-flat-rule OutputStream s
{
  [s print ([lhs name], " -> ")];
  [rhs describe-flat-rule s];
  [s nl];
}

OutputStream (s)
  writeFields OutputStream s
{
  = [[super writeFields s] print (" lhs=", [lhs name], " rhs=", rhs)];
}

int
  
cost
{
  = [rhs cost];
}

end;
